PImage colorBar;
String[] colorPath = {"bwReBlend129h.jpg"};
color c = color(255, 204, 0);

String color_representation = "";

void setColorScheme(DataRecord d){
  colorBar = loadImage(colorPath[0]);
  if(color_representation == "total_checkout"){
    c = colorBar.get((int)map(d.totalCheckout, min_totalCheckout, max_totalCheckout, 2, colorBar.width-2), colorBar.height/2);
    d.dataPointColor = c;
  }
  else if(color_representation == "publish_order"){
    c = colorBar.get((int)map(d.pubMapped[0], min_publishOrder, max_publishOrder, 2, colorBar.width-2), colorBar.height/2);
    d.dataPointColor = c;
  }
  else {
    d.dataPointColor = color(200);
  }
  
}

String getColorSchemeText(){
  if(color_representation == "total_checkout"){
    return "Color scheme: total checkouts";
  }
  else if(color_representation == "publish_order"){
    return "Color scheme: publication order";
  }
  else { return "Color scheme: Default"; }
}