int adoptionStart;
color dataPointColor;

float leftOffset;

float hoverDistance = 50;

void draw() {
  background(0);
  
  drawRecords();
  drawPlatform();
  drawLabels();
}

void drawRecords(){
    
  // iterate over records
  for (int i=0; i<dataRecords.length; i++){
    
    adoptionStart = 0;
    
    // iterate over each point in record
    for (int j=0; j<10; j++){
      strokeWeight(5);
      fill(dataRecords[i].dataPointColor);
      stroke(dataRecords[i].dataPointColor);
      pushMatrix();
      //println(dataRecords[i].pubMapped[j], dataRecords[i].countMapped[j], dataRecords[i].yearMapped[j]);
      translate(dataRecords[i].pubMapped[j] - leftOffset, -dataRecords[i].countMapped[j], dataRecords[i].yearMapped[j]);
      point(0,0,0);
      popMatrix();
      //checkMousePosition(dataRecords[i].pubMapped[j] - leftOffset, -dataRecords[i].countMapped[j], dataRecords[i].yearMapped[j], dataRecords[i]);
      
      // draw lines between points
      if(j<9){
        fill(dataRecords[i].dataPointColor);
        stroke(dataRecords[i].dataPointColor);
        strokeWeight(0.3);
        line(dataRecords[i].pubMapped[j] - leftOffset, -dataRecords[i].countMapped[j], dataRecords[i].yearMapped[j], dataRecords[i].pubMapped[j+1] - leftOffset, -dataRecords[i].countMapped[j+1], dataRecords[i].yearMapped[j+1]);
      }
    }
    
    // draw adoption line
    strokeWeight(1);
    stroke(0,255,0);
    fill(0,255,0);
    //println("I: ", i, " adp: ", dataRecords[i].adoptionMapped);
    line(dataRecords[i].pubMapped[0] - leftOffset, 0, 1000, dataRecords[i].pubMapped[0] - leftOffset, 0, 1000+dataRecords[i].adoptionMapped);

      
  }
}

void drawPlatform(){
  rotateX(PI/2);
  stroke(100);
  fill(100);
  translate(0, 0, -5);
  rect(-leftOffset, 0, 3*numRows, 1000);
  noStroke();
}

void checkMousePosition(float posX, float posY, float posZ, DataRecord d){
  if(mouseX >= posX - hoverDistance && mouseX <= posX + hoverDistance  && mouseY >= posY - hoverDistance && mouseY <= posY + hoverDistance){
    d.displayTitle(posX, posY, posZ);
    println("hover worked!");
    //d.displayLabel();
    //if(color_representation == "bookType"){
    //  String bookType = d.itemType;
    //  d.setColor(i, bookType);
    //}
  } else {
    
    //d.setColor(i, "null");
  }
}